namespace View_by_Distance.Shared.Models.Stateless.Methods;

public interface IPerson
{

    // ...

    bool TestStatic_IsDefaultName(string mappingDefaultName, string value) =>
        IsDefaultName(mappingDefaultName, value);
    static bool IsDefaultName(string mappingDefaultName, string value) =>
        value == mappingDefaultName || (value.Length > 1 && value[0] == 'Z' && value[1] == ']');

    bool TestStatic_IsDefaultName(string mappingDefaultName, Models.Person person) =>
        IsDefaultName(mappingDefaultName, person);
    static bool IsDefaultName(string mappingDefaultName, Models.Person person) =>
        IsDefaultName(mappingDefaultName, person.Name.Alias is null ? string.Empty : person.Name.Alias.Value);

    string TestStatic_GetFileFullName(Properties.IStorage storage, string personBirthdayFormat, Models.Person person) =>
        GetFileFullName(storage, personBirthdayFormat, person);
    static string GetFileFullName(Properties.IStorage storage, string personBirthdayFormat, Models.Person person) =>
        IPersonBirthday.GetFileFullName(storage, personBirthdayFormat, person.Birthday);

    Models.Person TestStatic_GetPerson(string mappingDefaultName, char[] personCharacters, string personDisplayDirectoryName, long personKey, Models.PersonBirthday personBirthday) =>
        GetPerson(mappingDefaultName, personCharacters, personDisplayDirectoryName, personKey, personBirthday);
    static Models.Person GetPerson(string mappingDefaultName, char[] personCharacters, string personDisplayDirectoryName, long personKey, Models.PersonBirthday personBirthday) =>
        Person.GetPerson(mappingDefaultName, personCharacters, personDisplayDirectoryName, Array.Empty<string>(), null, personKey, personBirthday, null);

    Models.Person TestStatic_GetPerson(string mappingDefaultName, char[] personCharacters, string personDisplayDirectoryName, string[] personDisplayDirectoryAllFiles, string personKeyFormatted, long personKey, string[]? filteredIndividualsLines) =>
        GetPerson(mappingDefaultName, personCharacters, personDisplayDirectoryName, personDisplayDirectoryAllFiles, personKeyFormatted, personKey, filteredIndividualsLines);
    static Models.Person GetPerson(string mappingDefaultName, char[] personCharacters, string personDisplayDirectoryName, string[] personDisplayDirectoryAllFiles, string personKeyFormatted, long personKey, string[]? filteredIndividualsLines) =>
        Person.GetPerson(mappingDefaultName, personCharacters, personDisplayDirectoryName, personDisplayDirectoryAllFiles, personKeyFormatted, personKey, IPersonBirthday.GetPersonBirthday(personKey), filteredIndividualsLines);

    (string[] headerLines, Dictionary<string, List<string>> individuals, string[] footerLines) TestStatic_GetIndividuals(string? gedCOMFile) =>
        GetIndividuals(gedCOMFile);
    static (string[] headerLines, Dictionary<string, List<string>> individuals, string[] footerLines) GetIndividuals(string? gedCOMFile) =>
        Person.GetIndividuals(gedCOMFile);

    string[] TestStatic_GetFiltered(List<string> individualsLines) =>
        GetFiltered(individualsLines);
    static string[] GetFiltered(List<string> individualsLines) =>
        Person.GetFiltered(individualsLines);

    void TestStatic_CreateTree(string mappingDefaultName, string personBirthdayFormat, string resultAllInOne, Models.PersonContainer[] personContainers, string[] gedCOMHeaderLines, string[] gedCOMFooterLines, long ticks, string a2PeopleContentDirectory, Dictionary<long, List<int>> personKeyToIds) =>
        CreateTree(mappingDefaultName, personBirthdayFormat, resultAllInOne, personContainers, gedCOMHeaderLines, gedCOMFooterLines, ticks, a2PeopleContentDirectory, personKeyToIds);
    static void CreateTree(string mappingDefaultName, string personBirthdayFormat, string resultAllInOne, Models.PersonContainer[] personContainers, string[] gedCOMHeaderLines, string[] gedCOMFooterLines, long ticks, string a2PeopleContentDirectory, Dictionary<long, List<int>> personKeyToIds) =>
        Person.CreateTree(mappingDefaultName, personBirthdayFormat, resultAllInOne, personContainers, gedCOMHeaderLines, gedCOMFooterLines, ticks, a2PeopleContentDirectory, personKeyToIds);

}